package model;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.OneToMany;
import javax.persistence.Table;

@Entity
@Table(name="grade1")
public class Grade {
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	private long id;

	private String name;

	@OneToMany(mappedBy = "grade", cascade = CascadeType.PERSIST)
	private List<Student> students =new ArrayList<Student>();

	public Grade() {
	}

	public Grade(long id, String name) {
		this(id, name, null);
	}

	public Grade(long id, String name, List<Student> students) {
		this.id = id;
		this.name = name;
		this.students = students;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public List<Student> getStudents() {
		return students;
	}

	public void setStudents(List<Student> students) {
		this.students = students;
	}

	public long getId() {
		return id;
	}

	@Override
	public String toString() {

		return getId() + ", " + getName() + ", "
				+ Arrays.deepToString(students.toArray());
	}

	public void addStudent(Student stud) {
		stud.setGrade(this);
		students.add(stud);
	}

}
