package model;

import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

@Entity
@Table(name="student1")
public class Student {
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	private long id;

	private String name;

	@Enumerated(EnumType.ORDINAL)
	private Zodiac zodiac;

	@ManyToOne
	private Grade grade;

	public Student() {
	}

	public Student(String name, Zodiac zodiac) {
		this(0, name, zodiac, null);
	}

	public Student(long id, String name, Zodiac zodiac, Grade grade) {
		this.id = id;
		this.name = name;
		this.zodiac = zodiac;
		this.grade = grade;
	}

	public Grade getGrade() {
		return grade;
	}

	public void setGrade(Grade grade) {
		this.grade = grade;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public Zodiac getZodiac() {
		return zodiac;
	}

	public void setZodiac(Zodiac zodiac) {
		this.zodiac = zodiac;
	}

	public long getId() {
		return id;
	}

	@Override
	public String toString() {
		return getId() + ", " + getName() + ", " + getZodiac();
	}
}
