CREATE TABLE GRADE(
GRADE_ID NUMBER(4) NOT NULL,
NAME VARCHAR2(40) NOT NULL,
CONSTRAINT GRADE_PK PRIMARY KEY(GRADE_ID),
CONSTRAINT GRADE_NAME_UNIQUE UNIQUE(NAME) 
);

CREATE SEQUENCE GRADE_SEQUENCE
START WITH 1
INCREMENT BY 1;

CREATE OR REPLACE TRIGGER GRADE_TRIGGER
BEFORE INSERT
ON GRADE
FOR EACH ROW
BEGIN
SELECT GRADE_SEQUENCE.nextval INTO :NEW.GRADE_ID FROM DUAL;
END;

-- Create Zodiac table 
CREATE TABLE ZODIAC(
ZODIAC_ID NUMBER(4) NOT NULL,
NAME VARCHAR2(40) NOT NULL,
CONSTRAINT ZODIAC_PK PRIMARY KEY(ZODIAC_ID),
CONSTRAINT ZODIAC_NAME_UNIQUE UNIQUE(NAME) 
);

CREATE SEQUENCE ZODIAC_SEQUENCE
START WITH 1
INCREMENT BY 1;

CREATE OR REPLACE TRIGGER ZODIAC_TRIGGER
BEFORE INSERT
ON ZODIAC
FOR EACH ROW
BEGIN
SELECT ZODIAC_SEQUENCE.nextval INTO :NEW.ZODIAC_ID FROM DUAL;
END;

-- Insert values in Zodiac table
INSERT INTO ZODIAC(NAME) VALUES('Aries');
INSERT INTO ZODIAC(NAME) VALUES('Taurus');
INSERT INTO ZODIAC(NAME) VALUES('Gemini');
INSERT INTO ZODIAC(NAME) VALUES('Cancer');
INSERT INTO ZODIAC(NAME) VALUES('Leo');
INSERT INTO ZODIAC(NAME) VALUES('Virgo');
INSERT INTO ZODIAC(NAME) VALUES('Libra');
INSERT INTO ZODIAC(NAME) VALUES('Scorpio');
INSERT INTO ZODIAC(NAME) VALUES('Sagittarius');
INSERT INTO ZODIAC(NAME) VALUES('Capricorn');
INSERT INTO ZODIAC(NAME) VALUES('Aquarius');
INSERT INTO ZODIAC(NAME) VALUES('Pisces');

-- Create Student table
CREATE TABLE STUDENT(
STUDENT_ID NUMBER(4) NOT NULL,
NAME VARCHAR2(40) NOT NULL,
ZODIAC_ID NUMBER(4) NOT NULL,
GRADE_ID NUMBER(4) NOT NULL,
CONSTRAINT STUDENT_PK PRIMARY KEY(STUDENT_ID),
CONSTRAINT ZODIAC_FK FOREIGN KEY (ZODIAC_ID) REFERENCES ZODIAC(ZODIAC_ID),
CONSTRAINT GRADE_FK FOREIGN KEY (GRADE_ID) REFERENCES GRADE(GRADE_ID)
);

CREATE SEQUENCE STUDENT_SEQUENCE
START WITH 1
INCREMENT BY 1;

CREATE OR REPLACE TRIGGER STUDENT_TRIGGER
BEFORE INSERT
ON STUDENT
FOR EACH ROW
BEGIN
SELECT STUDENT_SEQUENCE.nextval INTO :NEW.STUDENT_ID FROM DUAL;
END;

-- Task: 
--Използвайки JDBC да се напише заявка, която връща списък
-- от всички ученици с техните свойства (properties) 
-- като за всеки ученик се извежда и от кой клас е.
-- Пример
-- Иван, риби, 9а клас
-- Георги, овен, 4ж клас

SELECT
  S.STUDENT_ID "ID",
  S.NAME "NAME",
  Z.NAME "ZODIAC",
  G.NAME "GRADE"
FROM
  STUDENT S
INNER JOIN GRADE G ON S.GRADE_ID=G.GRADE_ID
INNER JOIN ZODIAC Z ON S.ZODIAC_ID=Z.ZODIAC_ID;

select * from student;

