package test.jpa;

import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.Query;

import model.Grade;
import model.Student;
import model.Zodiac;

public class TestJPA {

	@SuppressWarnings("unchecked")
	public static void main(String[] args) {
		EntityManagerFactory factory = null;
		EntityManager em = null;
		try {
			factory = Persistence.createEntityManagerFactory("model");
			em = factory.createEntityManager();

			em.getTransaction().begin();

			// Create and persist a new Grade entity
			Grade grade = new Grade();
			grade.setName("12Z");
			grade.addStudent(new Student("Nikolay", Zodiac.Cancer));
			grade.addStudent(new Student("Atanas", Zodiac.Libra));
			em.persist(grade);

			em.getTransaction().commit();

			// print result
			Query query = em.createQuery("select g from Grade g");
			for (Grade gr : (List<Grade>) query.getResultList()) {
				System.out
						.printf("id: %s, name: %s\n", gr.getId(), gr.getName());
				List<Student> studentsInGrade=gr.getStudents();
				for (Student student : studentsInGrade) {
					System.out.println(student);
				}
			}
		} catch (Exception e) {
			em.getTransaction().rollback();
		} finally {

			if (em != null) {
				em.close();
			}
			if (factory != null) {
				factory.close();
			}
		}
	}
}
